



/*
Chapter 1
*/


option nodate nonumber linesize=65 formdlim=" ";
/*
Program 1.1
*/
libname saslib '\\Vboxsvr\shared\SAS Book\dat';
libname desktop 'C:\Documents and Settings\ARTHUR\Desktop\desktop';

data noise1;   *creates NOISE1.SAS7BDAT in the library WORK;
    set saslib.noise;
run;

data desktop.noise1; /*becomes NOISE1.SAS7BDAT on w:\SAS Book\dat */
    set saslib.noise;
run;



/*
Program 1.2 This program reads the raw data file with fixed field by using the column input method.
*/
data hearing;
    infile "C:\Users\Arthur\Documents\SAS Book\dat\hearing.txt";
    input id $ 1 - 4
	    race $ 6
          smoke $ 8 - 14
          Age 16 - 17
          Preg 19
          Hearing $ 21 - 23
          Income 25 - 30;
run;


/*
Program 1.3 This program reads the data by using the DATALINES statement.
*/

data hearing_small;
    input id $ 1 - 4
	    race $ 6
          smoke $ 8 - 14
          Age 16 - 17
          Preg 19
          Hearing $ 21 - 23
          Income 25 - 30;
datalines;
629F H past    26 0      35000
656F W never   26 1 no   48000
711F W never   32 1 no   30000
733F W current 17 0      59000
135F B current 29 1 no  120000
982F W past    26 1 yes 113000
798F W never   19 0      28900
494F W never   36 0      65000
748F W never   34 1 no   39000
904F W never   25 0      76200
244F W never   28 1 yes  58000
747F A current 18 0      39000
796F A past    35 0     134000
713F H never   26 1 no   29000
745F A never   36 1 no   76000
184M W past    19 .      13900
;




/*
Program 1.4 This program adding three scores by using + operator and the SUM functions.
*/
data score;
    input ID $ 1-4 score1 6-7 score2 9-10 score3 12-13;
    score_sum1 = score1 + score2 + score3;
    score_sum2 = sum(score1, score2, score3);
datalines;
629F  5  6  9
656F  6 10  9
711F  0  .  3
511F  9  4 10
478F  .  5  3
;

title 'Adding Three Scores By Using + Operator and SUM Function';
proc print data=score;
run;

/*
Program 1.5 This program displays the description portion of the HEARING data set.
*/

title 'The Contents of Hearing Data';
proc contents data=hearing varnum;
run;


/*
Program 1.6
*/
proc sort data=hearing out=hearing_sort;
    by race descending preg descending age;
run;



/*
Program 1.7
*/
proc sort data=hearing_small out=hearing_small_sort;
    by race;
run;

title 'Print ID SMOKE and AGE variables by RACE';
proc print data=hearing_small_sort noobs;
    by race;
    var id smoke age;
run;


/*
Program 1.8
*/
title 'The Mean Procedure - Class Statement';
proc means data=hearing min median max maxdec=2 ;
    where race = 'W' or race = 'B';
    class smoke;
    var age;
run;

proc sort data=hearing;
    by smoke;
run;

title 'The Mean Procedure - By Statement';
proc means data=hearing min median max maxdec=2;
    where race = 'W' or race = 'B';
    by smoke;
    var age;
run;




/*
Program 1.9
*/
title 'No option';
proc freq data=hearing;
    tables preg;
run;

title 'Using MISSING option';
proc freq data=hearing;
    tables preg/missing;
run;

title 'Using MISSPRINT option';
proc freq data=hearing;
    tables preg/missprint;
run;


/*
Program 1.10
*/
title 'Without LIST option';
proc freq data=hearing;
     tables preg*race*smoke;
run;

title 'With LIST option';
proc freq data=hearing;
    tables preg*race*smoke/list;
run;




/*
Program 1.11
*/

data dat1;
    set hearing(keep = id smoke age);
run;



/*
Program 1.12
*/
data dat1;
    set hearing;
    keep id smoke age;
run;


/*
Program 1.13
*/

data dat2;
    set hearing (drop= race preg -- income);
run;

/*
Program 1.14
*/

data dat2;
    set hearing;
    drop race preg -- income;
run;


/*
Program 1.15
*/
data dat3 (drop= income);
    set hearing (keep= id income);
    if income > 50000 then income_hi = 1;
    else income_hi = 0;
run;


/*
Program 1.16
*/
data dat4 (keep= id race smoke) 
     dat5 (keep= id age preg);
    set hearing;
run;


/*
Program 1.17
*/
data hearing1_1;
    set hearing;
    label hearing = Hearing Loss
    income = "People's Income";
run;

title 'Assigning Labels Permanently';
proc print data=hearing1_1(obs=5) label ;
    var hearing income;
run;

proc contents data=hearing1_1;
run; 

/*
Program 1.18
*/

title 'Assign temporary label to RACE variable';
proc means data=hearing1_1 mean median std;
	label race = Ethnicity;
	class race;
	var income;
run; 









/*
Program 1.19
*/

data hearing1_2;
    set hearing;
    format smoke hearing $upcase5. income dollar11.2;
run;

title 'Assigning formats to variable';
proc print data=hearing1_2(firstobs=6 obs=12);
    var smoke hearing income;
run; 
