







options nodate nonumber linesize=65 formdlim=" ";
/* 
Program 10.1
*/

libname ch10 '\\Vboxsvr\shared\SAS Book\dat';
proc sort data=ch10.duplicates out=by_id_1 nodupkey;
	by id;
run;

proc sort data=ch10.duplicates out=by_id_grade_1 nodupkey;
	by id Grade;
run;

proc sort data=ch10.duplicates out=by_all_1 nodupkey;
	by _all_;
run;

title 'original';
proc print data=ch10.duplicates;
run;

title 'NODUPKEY: by ID';
proc print data=by_id_1;
run;

title 'NODUPKEY: by ID and GRADE';
proc print data=by_id_grade_1;
run;

title 'NODUPKEY: by ID, GRADE, and SCORE';
proc print data=by_all_1;
run;



/*
Program 10.2
*/
proc sort data=ch10.duplicates out=by_id_2 nodup;
	by id;
run;

proc sort data=ch10.duplicates out=by_id_grade_2 nodup;
	by id Grade;
run;

proc sort data=ch10.duplicates out=by_all_2 nodup;
	by _all_;
run;

title 'original';
proc print data=ch10.duplicates;
run;

title 'NODUP: by ID';
proc print data=by_id_2;
run;

title 'NODUP: by ID and GRADE';
proc print data=by_id_grade_2;
run;

title 'NODUP: by ID, GRADE, and SCORE';
proc print data=by_all_2;
run;

proc print data=ch10.duplicates;
run;

/*
Program 10.3
*/

data compare1;
	input studentID $ gender $ height $ weight1 weight2;
	format weight1 6.2;
	label weight1 = first weight value;
    datalines;
A01 M 67 154.3 154.7
A02 M 64 150.2 150.2
A03 F 58 149.1 149.2
A04 F 59 149.2 149.2
;

data compare2;
	input studentID $ gender $  height weight1;
    datalines;
A01 M 67 154.3
A02 M 64 150.3
A04 F 59 149.1
;

title 'PROC COMPARE: basic output';
proc compare base=compare1
             compare=compare2;
run;


/*
Program 10.4
*/
proc sort data=compare1;
	by gender;
run;

proc sort data=compare2;
	by gender;
run;

title 'PROC COMPARE: ID, BY and VAR statement';
proc compare base=compare1
             compare=compare2 
             brief;
	by gender;
	id studentID;
	var weight1;
run;


/*
Program 10.5
*/
title 'Compare variables with different variable names in different data sets';
proc compare base=compare1
             compare=compare2 
             brief;
	id studentID;
	var weight2;
	with weight1;
run;



/*
Program 10.6
*/
title 'Compare variables with different variable names in the same data sets';
proc compare base=compare1 brief;
	var weight1;
	with weight2;
run;

/*
Program 10.7
*/

data dat1;
    input s_name $ s_id $ e1 - e3;
    label e1 = English1 
          e2 = English2
          e3 = English3;
    datalines;
John A01 89 90 92
Mary A02 92 .  81
;
proc transpose data=dat1 
               out=dat1_out1            
               name=varname
               label=labelname
               prefix=score_;
run;

title 'Dat1 in the original form';
proc print data=dat1 label;    
run;

title 'Dat1 in transposed form';
proc print data=dat1_out1;    
run;


/*
Program 10.8
*/


proc transpose data=dat1 
               out=dat1_out2 
               label=labelname
               name=varname
               delim=_;
    var e1-e3;
    id s_name s_id;
	idlabel s_id;
run;

title 'The use of VAR, ID, and IDLABEL statements';
proc print data=dat1_out2;
run;

proc contents data=dat1_out2;
run;


/*
Program 10.9
*/
proc sort data=dat1 out=dat1_sort;
    by s_name;
run;

title 'DAT1_SORT where DAT1 is Sorted by S_NAME';
proc print data=Dat1_Sort;
run;

proc transpose data=dat1_sort 
	           out=dat1_out3 
			   name=varname
			   label=TEST;        
    by s_name;
    copy s_id;
run;

title 'Transposing BY-group with the COPY statement';
proc print data=dat1_out3;
run;



/*
Program 10.10
*/
proc transpose data=dat1_sort 
               out=dat1_out4 
			   name=varname
               label=TEST;
    by s_name;
    id s_id;
run;

title 'Incorrect way to use the ID statement';
proc print data=dat1_out4;    
run;

proc transpose data=dat1_sort 
               out=dat1_out5(rename=(col1=Score))
               name=varname
               label=TEST;
    by s_name;
run;
title 'Rename COL1 to SCORE in the Output Data Set';
proc print data=dat1_out5;    
run;



/*
Program 10.11
*/
data dat2;
    input s_name $ s_id $ exam score;
    datalines;
John A01 1 89
John A01 2 90 
John A01 3 92
Mary A02 1 92
Mary A02 3 81
;

proc sort data=dat2 out=dat2_sort;
    by s_name;
run;

proc transpose data=dat2_sort out=dat2_out1;	
    var score;
    by s_name;
run;

title 'Incorrect way to transpose - ID statement is not used';
proc print data=dat2_out1;    
run;


/*
Program 10.12
*/
proc transpose data=dat2_sort 
               out=dat2_out2(drop=_name_)
               prefix=test_;
    var score;
    by s_name;
    id exam;
run;

title 'Correct way to transpose - ID statement is used';
proc print data=dat2_out2;
run;


/*
Program 10.13
*/

data dat3;
    input s_name $ s_id $ exam score;
    datalines;
John A01 1 89
John A01 2 90
John A01 3 92
John A01 3 95
Mary A02 1 92
Mary A02 3 81
Mary A02 3 85
;

proc sort data=dat3 out=dat3_sort;
    by s_name exam score;
run;

proc transpose data=dat3_sort 
               out=dat3_out(drop=_name_)
               prefix=test_ 
               let;
    var score;
    by s_name;
    id exam;
run;

title 'Keep the maximum score';
proc print data=dat3_out;
run;



/*
Program 10.14A
*/
data dat4;
   input s_name $ E1 - E3 M1 - M3;
datalines;
John 89 90 92 78 89 90
Mary 92 .  81 76 91 89
;       
 
proc sort data=dat4 out=dat4_sort1;
    by s_name;
run;

proc transpose data=dat4_sort1 out=dat4_out1;
    by s_name;
run;
                                                          
title 'First use of PROC TRANSPOSE for dat4';
proc print data=dat4_out1;
run;




/*
Program 10.14B
*/
data dat4_out1a;                                                     
    set dat4_out1;                                                  
    test_num=substr(_name_,2);                                
    class=substr(_name_,1,1);                               
run;      

title 'Creating TEST_NUM and CLASS variables';
proc print data=dat4_out1a;
run;


/*
Program 10.14C
*/

proc sort data=dat4_out1a out=dat4_sort2;                                           
    by test_num s_name class;                                           
run;


title 'Sort data by TEST_NUM, S_NAME and CLASS';
proc print data=dat4_sort2;
run;   


/*
Program 10.14D
*/

proc transpose data=dat4_sort2
               out=dat4_out2(drop=_name_)
               delimiter=_;     
    by test_num;                                                
    var col1;                                                   
    id s_name class;
run;         

title 'Second use of PROC TRANSPOSE for dat4';
proc print data=dat4_out2;
run;


/*
Program 10.15
*/



libname desktop 'C:\Documents and Settings\xueli\Desktop';
libname library 'C:\Documents and Settings\xueli\Desktop\saslib';
proc format;
    value $race
        'A' = 'Asian'
        'B' = 'African American'
        'H' = 'Hispanic'
        'W' = 'White';
    value yesno
        1 = 'Yes'
        0 = 'No';
	value $smkfmt 'past', 'never' = '0'
		          'current' ='1';
run;

proc format library=desktop.salary;
    value salfmt
        low - <50000 = 'low'
        50000 - <100000 = 'average'
        100000 - high = 'high';
run;

proc format library=desktop;
    value agefmt
        low - <30 = '< 30'
        30 - high = '>= 30'
		other = 'missing';
run;

/*
Program 10.16
*/

option linesize=76;
title 'Contents in WORK.FORMAT catalog';
proc format fmtlib;
run;

title 'Contents in DESKTOP.FORMAT catalog';
proc format library=desktop fmtlib;
run;

title 'Contents in DESKTOP.SALARY catalog';
proc format library=desktop.salary fmtlib;
run;
option linesize=65;


/*
Program 10.17
*/
data hearing;
    *infile "\\Vboxsvr\shared\SAS Book\dat\hearing.txt";
    infile "W:\Xuejun Li\SAS Book\dat\hearing.txt";
    input id $ 1 - 4
	      race $ 6
          smoke $ 8 - 14
          Age 16 - 17
          Preg 19
          Hearing $ 21 - 23
          Income 25 - 30;
run;

option fmtsearch=(desktop desktop.salary);
data hearing2;
    set hearing;
    format race $race.
           preg yesno.
		   smoke $smkfmt.
           age agefmt.
           income salfmt.;
run;

title 'Data set HEARING, formats are not used';
proc print data=hearing (obs=5);
	var id race preg smoke age income;
run;

title 'Data set HEARING2, formats are used';
proc print data=hearing2 (obs=5);
    var id race preg smoke age income;
run;

title 'Cross tabulation of AGE and INCOME by using formatted value';
proc freq data=hearing2;
	tables age*income/missing;
run;



/*
Program 10.18
*/
data hearing3;
	set hearing;
	preg_char = put(preg, yesno.);
	smoke_ind = input(put(smoke, $smkfmt.), 1.);
run;

title 'Checking if PREG_CHAR and SMOKE_IND are created correctly';
proc freq data=hearing3;
	tables preg*preg_char smoke*smoke_ind/nocol norow nopercent missing;
run;



/*
Program 10.19
*/

options nodate nonumber linesize=65 formdlim=" ";
proc options GROUP=LISTCONTROL;
run;

/*
Program 10.20
*/
proc options option=linesize;
run;
