

option nodate nonumber linesize=65 formdlim=" ";

/*
Program 4.1
*/

data sas4_1;
	input ID $	SCORE;
datalines;
A01	3
A01	3
A01	2
A02	4
A02	2
;


proc sort data=sas4_1;
    by id;
run;

data sas4_2 (drop = score);
    set sas4_1;
    by id;
    if first.id then total = 0;
    total + score;
    if last.id; 
run;

title 'The total scores for each subject';
proc print data=sas4_2;
run;


/*
Program 4.2
*/

data sas4_mean (drop=score);
    set sas4_1;
    by id;
    if first.id then do;
		total = 0;
		n = 0;
	end;
    total + score;
	n + 1;
    if last.id then do;
    	mean_score = total/n;
		output;
	end; 
run;

title 'The mean scores for each subject';
proc print data=sas4_mean;
run;


/*
Program 4.3
*/
proc sort data=sas4_1;
    by id score;
run;

data sas4_1_s sas4_1_d;
    set sas4_1;
    by id score;
    if first.score and last.score then output sas4_1_s;
    else output sas4_1_d;
run;

title 'Non-duplciated records';
proc print data=sas4_1_s;
run;

title 'Duplciated records';
proc print data=sas4_1_d;	
run;




/*
Program 4.4
*/
** prepare data;
data patients;
	input patid $ visit tgl smoke $;
datalines;
A01	2005	.	Y
A01	2007	150	.
A02	2004	.	.
A02	2005	200	N
A02	2006	210	N
A03	2005	.	Y
A04	2002	164	.
A04	2004	170	Y
A04	2006	190	.
A04	2007	.	N
A05 2005    189 .
;

proc sort data=patients out=patients_sort;
	by patid visit;
run;

data patients_single (drop= visit tgl smoke);
	set patients_sort;
	by patid;
	retain tgl_new smoke_new;
	if first.patid then do;
		tgl_new = .;
		smoke_new = " ";
	end;
	if not missing(tgl) then tgl_new=tgl;
	if not missing(smoke) then smoke_new=smoke;
	if last.patid;
run;

title 'The data contains the most current non-missing values';
proc print data=patients_single;	
run;


/*
Program 4.5
*/
data long;
	input id $ time score;
datalines;
A01	1	3
A01	2	4
A01	3	5
A02	1	4
A02	3	2
;
proc sort data=long;
    by id time;
run;

data wide (drop=time score);
    set long;
    by id;
    retain s1-s3;
    if first.id then do;
        s1 = .;  s2 = .; s3 = .;
    end;
    if time = 1 then s1 = score;
    else if time = 2 then s2 = score;
    else s3 = score;
    if last.id;
run;

proc print data=wide;
run;
