

option nodate nonumber linesize=65 formdlim=" ";

/*
Program 5.1
*/
data patient;
	input ID $;
datalines;
M2390
F2390
F2340
M1240
;

data ex5_1 (drop=rannum);
    set patient;
    rannum = ranuni(2);
    if rannum > 0.5 then group = 'D';
    else group = 'P';
run;

title 'Assigning patients to different groups';
proc print data=ex5_1;
run;


/*
Program 5.2
*/

data ex5_2(drop=rannum);
    id = 'M2390';
    rannum = ranuni(2);				
    if rannum> 0.5 then group = 'D';	
    else group ='P';
    output;

    id = 'F2390';
    rannum = ranuni(2);				
    if rannum> 0.5 then group = 'D';	
    else group ='P';
    output;

    id = 'F2340';
    rannum = ranuni(2);				
    if rannum> 0.5 then group = 'D';	
    else group ='P';
    output;

    id = 'M1240';
    rannum = ranuni(2);				
    if rannum> 0.5 then group = 'D';	
    else group ='P';
    output;
run;


proc print;
run;

/*
Program 5.3
*/
data ex5_3(drop = rannum);
    do id = 'M2390', 'F2390', 'F2340', 'M1240';
        rannum = ranuni(2);		
        if rannum>0.5 then group = 'D';
        else group ='P';
        output;
    end;
run;

/*
Program 5.4:
*/
data ex5_4 (drop = rannum);
    do id = 1 to 4;
        rannum = ranuni(2);		
        if rannum> 0.5 then group = 'D';
        else group ='P';
        output;
    end;
run;

/*
Program 5.5:
*/
data ex5_5(drop=rannum);
    do while (id <4);
        id + 1;
        rannum = ranuni(2);
        if  rannum> 0.5 then group = 'D';
        else group ='P';
        output;
    end;
run;


/*
Program 5.6:
*/
data ex5_6(drop=rannum);
    do until (id >=4);
        id +1;
        rannum = ranuni(2);
        if rannum > 0.5 then group = 'D';
        else group ='P';
        output;
    end;
run;



/*
Program 5.7:
*/

data ex5_7;
   length center $4;
   do center = "COH", "UCLA", "USC";  	
      do id = 1 to 4;   			
         if ranuni(2) > 0.5 then group = 'D';
         else group ='P';
         output;
      end;					
   end;					
run;

title 'Using nested iterative loops';
proc print data=ex5_7;
run;

/*
Program 5.8
*/

data cancer_center;
	input center $;
datalines;
COH
UCLA
USC
;


data ex5_8;
    set cancer_center;
    do id = 1 to 4;
        if  ranuni(2)> 0.5 then group = 'D';
        else group ='P';
        output;
    end;
run;


/*
Program 5.9
*/
data sbp;
	input id $	sbp;
datalines;
01	145
02	119
03	126
04	106
05	151
06	112
07	127
08	119
09	113
;
data ex5_9;
    obs_n = 5;
    set sbp point= obs_n;
    output;
    stop;
run;

title 'Select the fifth observation from SBP data set';
proc print data=ex5_9;
run;



/*
Program 5.10
*/
data ex5_10;
    do choose = 1 to total by 3;
        set sbp point=choose nobs=total;
        output;
    end;
    stop;
run;

title 'Select every third observation from SBP data set';
proc print data=ex5_10;
run;

/*
Program 5.11
*/
data ex5_11 (drop= i);
    do i =1 to 3;
        choose = ceil(ranuni(5)*total);
        set sbp point=choose nobs=total;
        output;
    end;
    stop;
run;

title 'Select a random sample with replacement';
proc print data=ex5_11;
run; 

/*
Program 5.12
*/
data ex5_12 (drop=pct size left randnum);
    size = 3;
    left = total;
    do while (size > 0);
        choose + 1;
        randnum = ranuni(12);
        pct = size / left;
        if randnum < pct then do;
            set sbp point=choose nobs=total;
            output;
            size = size - 1;
        end;
        left = left - 1;		
    end;
    stop;
run;

title 'Select a random sample without replacement';
proc print data=ex5_12;
run;

/*
Program 5.13
*/
data ex5_13;
    infile "C:\text1.txt";
    input id $ sbp;	
run;

proc print;
run;

/*
Program 5.14
*/
data ex5_14;
    infile "C:\text1.txt" end=last;
    do until(last= 1);			
        input id $ sbp;									
        output;										
    end;			
run;
proc print;
run;

/*
Program 5.15
*/
data ex5_15;
    filename = "C:\text1.txt";
    infile dummy filevar =filename;		
    input id $ sbp;						
run;
proc print;
run;

/*
Program 5.16
*/
data ex5_16(drop=i);	
    do i = 1 to 3; 				
        next = "C:\text" || put(i, 1.) || ".txt";
        infile temp filevar = next;	
        fileName = next;	
        input id $ sbp;				
        output;
    end;					
    stop;  
run;

title 'Reading multiple external files - first attempt';
proc print data=ex5_16;
run;

/*
Program 5.17
*/
data ex5_17(drop=i);
    do i = 1 to 3;
        next = "C:\text" || put(i, 1.)|| ".txt";
        do until (last);				
            infile dummy filevar = next end=last;
            fileName = next;
            input id $ sbp;			
            output;					
        end;						
    end;						
    stop;
run;


title 'Reading multiple external files - second attempt';
proc print data=ex5_17;
run;
