

option nodate nonumber linesize=65 formdlim=" ";

/*
Program 6.1
*/


data sbp;
	input sbp1-sbp6;
datalines;
141	142	137	117	116	124
999	141	138	119	119	122
142	999	139	119	120	999
136	140	142	118	121	123
;

proc print data=sbp;
run;

data ex6_1;
    set sbp;
    if sbp1 = 999 then sbp1 = .;
    if sbp2 = 999 then sbp2 = .;
    if sbp3 = 999 then sbp3 = .;
    if sbp4 = 999 then sbp4 = .;
    if sbp5 = 999 then sbp5 = .;
    if sbp6 = 999 then sbp6 = .;
run;

/*
Program 6.2
*/

data ex6_2(drop=i);
    set sbp;
    array sbpary[6] sbp1-sbp6;
    do i = 1 to 6;
        if sbpary[i] = 999 then sbpary[i] = .;
    end;	
run;

/*
Program 6.3
*/
data ex6_3(drop=i);
    set sbp;
    array sbpary[*] _numeric_;
    do i = 1 to dim(sbpary);
        if sbpary[i] = 999 then sbpary[i] = .;
    end;	
run;



/*
Program 6.4
*/
data sbp2;
	input sbp1-sbp6;
datalines;
141	142	137	117	116	124
.	141	138	119	119	122
142	.	139	119	120	.
136	140	142	118	121	123
;

data ex6_4;
	set sbp2;
	array sbpary[*] _numeric_;
	miss = . IN sbpary;
run;

title 'Using the IN operator to create variable MISS';
proc print data=ex6_4;
run;



/*
Program 6.5
*/
data ex6_5;
	set sbp2;
	array sbpary[*] _numeric_;
    sbp_min = min(of sbpary[*]);
	sbp_max = max(of sbpary[*]);
run;

title 'Using the OF operator to create variables SBP_MIN and SBP_MAX';
proc print data=ex6_5;
run;


/*
Program 6.6
*/
data ex6_6(drop=i);
    set sbp2;
    array sbp[6]; 
    array above[6];
    array threshhold[6] _temporary_ (140 140 140 120 120 120); 
    do i = 1 to 6;
        if (not missing(sbp[i])) 
            then above[i] = sbp[i] > threshhold[i];
    end;	
run;

title 'Creating variables ABOVE1 - ABOVE6';
proc print data=ex6_6;
run;

/*
Program 6.7
*/
data product;
	input num1-num4;
datalines;
4	.	2	3
.	2	3	1
;


data ex6_7(drop=i);
    set product;
    array num[4];
    if missing(num[1]) then result = 1;
    else result = num[1];
    do i = 2 to 4;
        if not missing(num[i]) then result =result*num[i];
    end;
run;

title 'Calculating the product of NUM1-NUM4';
proc print data=ex6_7;
run;

/*
Program 6.8
*/
data wide;
	input ID $ S1-S3;
datalines;
A01	3	4	5
A02	4	.	2
;

data ex6_8(drop=s1-s3);
    set wide;
    array s[3];
    do time =1 to 3;
        score = s[time];
        if not missing(score) then output;
    end;
run;


/*
Program 6.9
*/
data long;
	input ID $ time score;
datalines;
A01	1	3
A01	2	4
A01	3	5
A02	1	4
A02	3	2
;

proc sort data=long;
    by id;
run;

data ex6_9 (drop=time score i);
    set long;
    by id;
    array s[3];
    retain s;
    if first.id then do;
        do i = 1 to 3;
            s[i] = .;
	    end;
    end;
    s[time] = score;
    if last.id;
run;

proc print data=ex6_9;
run;




/*
Program 6.10
*/
data ex6_10 (drop = i j);
    set sbp2;
    array sbp[2, 3];
    array sbpmean[2];
    array n[2] _temporary_;
    array sbpsum [2] _temporary_;
    do i = 1 to 2;
        sbpsum[i] = 0;
        n[i] = 0;
        do j = 1 to 3;
            sbpsum[i] + sbp[i,j];	
			if not missing(sbp[i,j]) then n[i] + 1;
        end;
        sbpmean[i] = sbpsum[i]/n[i];
    end;		
run;
title 'Calculating the average of SBP for pre- and post-treatment';
proc print data=ex6_10;
run;

/*
Program 6.11
*/
data dat1;
	input ID (G1-G3) ($);
datalines;
1	A	B	F
1	B	A	C
2	B	A	D
2	C	B	C
;
proc print data=dat1;
run;


proc sort data=dat1;
    by id;
run;

data dat2(drop=i j g1 - g3);
    set dat1;
    by id;
    array all_g [2,3] $ m_g1 - m_g3 f_g1 - f_g3;
    array g[3];
    retain all_g;
    if first.id then i = 0;
    i + 1;
    do j = 1 to 3;
        all_g[i,j] = g[j];
    end;
    if last.id;
run;

proc print data=dat2;
run;


/*
Program 6.12
*/
data dat1(drop=i j m_g1 -- f_g3);
    set dat2;
    array all_g[2,3] m_g1 -- f_g3;
    array g[3] $;
    do i = 1 to 2;
        do j = 1 to 3;
            g[j] = all_g[i,j];
        end;
	    output;
    end;
run;






