

option nodate nonumber linesize=65 formdlim=" " center;
data record1;
	input Name $ 1-4 Course $ 6-9 Score;
datalines;
John MATH 90
John MATH 85
Mary MATH .
Tom	 MATH 92
;

data record2;
	input Name $ 1-4 Course $ 6-12 Grade;
datalines;
Joe  ENGLISH 96
John ENGLISH 89
Mary ENGLISH 78
Tom	 ENGLISH .
Dave ENGLISH 98
;

proc print data=record1;
proc print data=record2;
run;


/*
Program 7.1
*/

data ex7_1;
	set record1 record2;
run;

title 'Concatenating record1 and record2';
proc print data=ex7_1;
run;

/*
Program 7.2
*/
data ex7_2;
	length Course $ 7;
	set record1 
        record2(rename=(grade=score));
run;

title 'Renaming the GRADE variable before concatenating the data';
proc print data=ex7_2;
run;

/*
Program 7.3
*/
proc sort data=record1 out=record1_sort;
	by Name;
run;

proc sort data=record2 out=record2_sort;
	by Name;
run;

data ex7_3;			
	length Course $ 7;	
	set record1_sort record2_sort;
	by Name;				        
run;

title 'Interleaving record1 and record2';
proc print data=ex7_3;
run;

/*
Program 7.4
*/

data ex7_4;
	set record1;
	set record2;
run;

title 'Use One-to-one reading to combine record1 and record2';
proc print data=ex7_4;
run;





/*
Program 7.5
*/
proc means data=record1 noprint;
	var score;
	output out=record1_mean mean=mean_score;
run;

data ex7_5;
	set record1;
	if _n_=1 then set record1_mean(keep=mean_score);
run;

title 'Use One-to-one reading to merge the mean score with record1';
proc print data=ex7_5;
run;


/*
Program 7.6
*/

data ex7_6;                
	merge record1 record2;  
run;

title 'Use One-to-one merging to combine record1 and record2';
proc print data=ex7_6;
run;

/*
Program 7.7
*/
data ex7_7;									  
	merge record1_sort 
		  record2_sort;	
	by Name;				        
run;
title 'Use match-merge to combine record1 and record2';
proc print data=ex7_7;
run;


/*
Program 7.8
*/
data ex7_8;									  
	merge record1_sort(drop=course rename=(score=Math_score)) 
		  record2_sort(drop=course rename=(grade=English_score)) ;	
	by Name;				        
run;

title 'An improved approach to merge record1 and record2';
proc print data=ex7_8;
run;


/*
Program 7.9
*/

data ex7_9;
    merge record1_sort(drop=course 
                       rename=(score=Math_score) 
                       in=in_record1)
          record2_sort(drop=course 
                       rename=(grade=English_score) 
                       in=in_record2);	
	by Name;				        
	if in_record1 and in_record2;
run;

title 'Excluding unmatched observations';
proc print data=ex7_9;
run;

/*
Program 7.10
*/
data record3;
	input Name $ Grade;
datalines;
Joe 	.
John	.
Mary	82
Tom		90
Dave	97
;
proc print data=record3;
run;


proc sort data=record3 out=record3_sort;
    by Name;
run;

data ex7_10;
    update record2_sort record3_sort;
    by name;
run;

title 'Updating record2 data set';
proc print data=ex7_10;
run;
