
/* 
Program 8.1
*/

option nodate nonumber linesize=65 formdlim=" ";
data ex8_1;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_1.txt" truncover;
    input Name   $ 1 - 14
	      Gender $ 16
		  Age	 17 - 18
		  City   $ 20 - 30;
run;

title 'Using the column input method and the TRUNCOVER option';
proc print data=ex8_1;
run;



/*
Program 8.2
*/
data ex8_2;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_2.txt" pad;
    input @1  Name   $14.
	      +1  Ethnic $1.
		  @18 DOB    mmddyy10.
          +2  Income comma10.;
run;

title 'Using the formatted input method and the PAD option';
proc print data=ex8_2;
run;

proc contents data=ex8_2 varnum;
run;


/*
Program 8.3
*/
data ex8_3;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_3.txt";
    input fname $ lname $ age family children;
run;

title 'Using the list input method';
proc print data=ex8_3;
run;

/*
Program 8.4
*/
data ex8_4;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_4.txt" missover;
	length fname $11.;
    input fname $ lname $ age family children;
run;

title 'Using the LENGTH statement and the MISSOVER option';
proc print data=ex8_4;
run;



/*
Program 8.5
*/
data ex8_5;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_5.txt" dsd;
    input group $ fname $ lname $ age family children;
run;

title 'Using the DSD option';
proc print data=ex8_5;
run;


/*
Program 8.6
*/
data ex8_6;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_6.txt";
    input fname : $11. lname $ city & $13. income : comma.;
run;

title 'Using the modified list input method';
proc print data=ex8_6;
run;


/*
Program 8.7
*/
data ex8_7;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_7.txt";
    input Name   $ 1 - 14
	      Ethnic $ 16
		  Income : comma.
		  city & $13.;
run;

title 'Using the mixed input method';
proc print data=ex8_7;
run;



/*
Program 8.8
*/
data ex8_8;
	infile "\\Vboxsvr\shared\SAS Book\dat\ch8_8.txt";
    input fname : $11. lname $ /
          ethnic $ city & $ /
          income : comma.;
run;

title 'Using forward slash (/) pointer-control';
proc print data=ex8_8;
run;



/*
Program 8.9
*/
data ex8_9;
	infile "\\Vboxsvr\shared\SAS Book\dat\ch8_8.txt";
    input #2 ethnic $ city & $
          #1 fname : $11. lname $ 
          #3 income : comma.;
run;

title 'Using #n pointer-control';
proc print data=ex8_9;
run;


/*
Program 8.10
*/
data ex8_10;
	infile "\\Vboxsvr\shared\SAS Book\dat\ch8_9.txt";
    input fname $ lname $ age @@;
run;

title 'Using the double at sign(@@)';
proc print data=ex8_10;
run;


/*
Program 8.11
*/
data ex8_11;
    infile "\\Vboxsvr\shared\SAS Book\dat\ch8_1.txt" truncover;
    input age 17 - 18 @;
	if age > 30;
	input Name   $ 1 - 14
		  Gender $ 16
		  City   $ 20 - 30;
run;

title 'Using the single at sign(@)';
proc print data=ex8_11;
run;


/*
Program 8.12
*/

data _null_;
	set ex8_1;
    file "\\Vboxsvr\shared\SAS Book\OUT\ex8_1_out.txt";
    put name 1 - 14
	    age  16 - 17
		city 19 - 29;
run;

/*
Program 8.13
*/
data _null_;
	set ex8_2;
    file "\\Vboxsvr\shared\SAS Book\OUT\ex8_2_out.txt";
    put @1 name $14.
	    +1 dob mmddyyc8.
		+2 income dollar13.2-l;
run;

/*
Program 8.14
*/


data _null_;
	set ex8_1;
    file "\\Vboxsvr\shared\SAS Book\OUT\ex8_3_out.txt";
    put name age city;
run;


