

option nodate nonumber linesize=65 formdlim=" ";
/* 
Program 9.1
*/

data ex9_1;
    x1 = 5; 
    x2 = 3; 
    x3 = 4;
    y1 = 3; 
    y2 = .;
	array x[3];
	array y[2];

    m1 = mean(of _numeric_);
    m2 = mean(of x:, 1);
    m3 = mean(of x1--y1);
    m4 = mean(of x1-x3);
    m5 = mean(x1-x3);
    m6 = mean(of x1-x3, of y:);
	m7 = mean(of x[*], of y[*]);
run;

title 'The use of the MEAN function';
proc print data=ex9_1;
	var m1-m7;
run;


/*
Program 9.2
*/
libname ch9 'W:\Xuejun Li\SAS Book\dat';
data ex9_2;
    set ch9.noise;
    if sum(of noise:)> 20 then call missing (of noise:);
run;
title 'Set SCORES to missing if their sum is Greater than 20';
proc print data=ex9_2 (obs=5);
run;



/*
Program 9.3
*/

title 'Constructing date and time values';
data ex9_3;
	current_date = today();
	current_time = time();
	current_dateime = datetime();
	date1 = mdy(8,31,2012);
	date2 = yyq(2012,3);
	time = hms(6,12,30);
    datetime = dhms(current_date, 6,12,30);
	file print;
	put 'current_date:    ' current_date date9.;
	put 'current_time:    ' current_time time.;
	put 'current_dateime: ' current_dateime datetime.;
	put 'date1:           ' date1 date9.;
	put 'date2:           ' date2 date9.;
	put 'time:            ' time time.;
	put 'datetime:        ' datetime datetime.;
run;


/*
Program 9.4
*/
*libname ch9 '\\Vboxsvr\shared\SAS Book\dat';
libname ch9 'W:\Xuejun Li\SAS Book\dat';
data ex9_4;
	set ch9.tenant;
	if year(move_in_date) =1987 and month(move_in_date) = 8;
run;
title 'People who moved in Aug 1987';
proc print data=ex9_4;
	var id name move_in_date;
run;

/*
Program 9.5
*/

data ex9_5;
	set ch9.tenant;
	move_in_years = intck('year', move_in_date, today());
	anniversary2 = intnx('year', move_in_date, 2, 's');
run;

title 'Illustrating the use of INTCK and INTNX functions';
proc print data=ex9_5 (obs=5);
	var move_in_date move_in_years anniversary2;
	format anniversary2 date9.;
run;


/*
Program 9.6
*/
data ex9_6;
	set ch9.tenant;
	new_name = propcase(name);
	new_comments = upcase(comments);
run;

title 'Illustrating the use of PROPCASE and LOWCASE functions';
proc print data=ex9_6 (obs=5);
	var name new_name comments new_comments;
run;



/*
Program 9.7
*/
data ex9_7;
	set ch9.tenant;
	phone = area_code||'-'||phone1||'-'||phone2;
run;

title 'Illustrating the use of the concatenating operator';
proc print data=ex9_7(obs=5);
	var area_code phone1 phone2 phone;
run;


/*
Program 9.8
*/

data ex9_8;
	set ch9.tenant;
	phone_number1 = area_code||'-'||trim(left(phone1))||'-'||trim(left(phone2));
	phone_number2 = area_code||'-'||strip(phone1)||'-'|| strip(phone2);
	phone_number3 = catx('-', area_code, phone1, phone2);
run;

title 'Eliminating the gaps in the PHONE variable';
proc print data=ex9_8 (obs=5);
	var area_code phone1 phone2 phone_number1 phone_number2 phone_number3;
run;



/*
Program 9.9
*/
data ex9_9;
	set ch9.tenant;
	length fname lname $ 20 newid $ 3 gender $ 1;
	fname = scan(name, 1);
	lname = scan(name, 2);
	newid = substr(id, 1, 3);
	gender = substr(id, 4);
	if index(lowcase(comments),'sleep ok') > 0;
run;

title 'The use of SCAN, SUBSTR(right of =) and INDEX functions';
proc print data=ex9_9;
	var name fname lname id newid gender comments;
run;




/*
Program 9.10
*/
data ex9_10;
	set ch9.tenant;
	id2 = id;
	if substr(id2, 4) ="M" then substr(id2, 4) ="1";
	else substr(id2, 4) ="0";
	new_comments = tranwrd(comments, 'Booming', 'Boom');
run;

title 'The use of SUBSTR(left of =) and TRANWRD functions';
proc print data=ex9_10 (obs=5);
	var id id2 comments new_comments;
run;


/*
Program 9.11
*/
data income;
	input name $ income1 $ income2 $;
datalines;
John 123000 123,000
Mary 131000 131,000
;

data ex9_11;
	set income;
	month_income1 = income1/12;
	month_income2 = income2/12;
run;

title 'Automatic character-to-numeric conversion';
proc print data=ex9_11;
run;


/*
Program 9.12
*/
data ex9_12;
	set income;
	month_income1 = input(income1, 6.)/12;
	month_income2 = input(income2, comma7.)/12;
run;

title 'Using INPUT function to convert character values to numeric';
proc print data=ex9_12;
run;



/*
Program 9.13
*/
data ex9_13;
	set ch9.tenant;
	new_comments = input(comments, $upcase30.);
run;

title 'Using INPUT function to convert character values to uppercase';
proc print data=ex9_13 (obs=5);
	var comments new_comments;
run;




/*
Program 9.14
*/
data ex9_14;
	set ch9.tenant;
	phone_number = area_code || '-' || put(phone1, 3.) ||
		'-' || put(phone2, 4.);
run;
title 'Using PUT function to convert numeric values to character';
proc print data=ex9_14 (obs=5);
	var area_code phone1 phone2 phone_number;
run;


/*
Program 9.15
*/

data ex9_15;
    set ch9.tenant;
    new_comments = put(comments, $upcase30.);
run;

title 'Using PUT function to reformat the COMMENTS variable';
proc print data=ex9_15 (obs=5);
    var comments new_comments;
run;












